/**
 * Author: Michael Daniels
 * Key:	Zaltron
 **/

Edge
	var
		Vertex
			a
			b
		cost

	/**
	 * Function:    New(Vertex a, Vertex b, int weight)
	 * Desc:        Edge Constructor.
	 * Return Type: Edge
	 **/
	New(Vertex/_a, Vertex/_b, _cost)
		..()
		a = _a
		b = _b
		cost = _cost

	/**
	 * Function:    getStart()
	 * Desc:        Returns the Vertex the Edge starts from.
	 * Return Type: Vertex
	 **/
	proc/getStart()
		return a

	/**
	 * Function:    getEnd()
	 * Desc:        Returns the Vertex the Edge points to.
	 * Return Type: Vertex
	 **/
	proc/getEnd()
		return b

	/**
	 * Function:    getWeight()
	 * Desc:        Returns the cost of the Edge.
	 * Return Type: int
	 **/
	proc/getCost()
		return cost

	/**
	 * Function:    compareTo(Edge e)
	 * Desc:        Checks to see if one Edge's cost is great than, less than, or equal to another Edge's cost.
	 * Return Type: int
	 **/
	proc/compareTo(Edge/e)
		if(cost < e.cost)return -1
		if(cost > e.cost)return 1
		return 0