/**
 * Author: Michael Daniels
 * Key:	Zaltron
 **/

#define vWHITE 0
#define vGREY 1
#define vBLACK 2

/**
 * Function:	hasPath(Graph g, Vertex start, Vertex end)
 * Desc:		Checks to see if there is a path between Vertex A and Vertex B.
 * Return Type: boolean
 **/
proc/hasPath(Graph/g, Vertex/start, Vertex/end)
	var/visted = list()
	return hasPathHelper(g, start, end, visted)

/**
 * Function:	hasPathHelper(Graph g, Vertex start, Vertex end, list visted)
 * Desc:		See hasPath Desc.
 * Return Type: boolean
 **/
proc/hasPathHelper(Graph/g, Vertex/start, Vertex/end, list/visted)
	visted[start.getLabel()] = 1
	if(start == end)
		return TRUE
	for(var/Edge/e in g.getAdjList(start))
		var/Vertex/m = e.b
		if(visted[m.getLabel()] == 1)
			continue
		return hasPathHelper(g, m, end, visted)
	return FALSE